﻿<%@ Page Language="C#"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<script runat="server">

    //You must set a CORS configuration on your bucket to upload with HTML5. Uncomment the code around SetBucketCors()
    //to set a CORS configuration if one does not exist. The code uses the free SprightlySoft AWS Component for .NET to
    //set the CORS configuration. See http://sprightlysoft.com/AWSComponent/

    //You must upload the crossdomain.xml file in this project to the root of your bucket to upload with Flash 
    //and Silverlight. You must make this file public (everyone view permission).

    //Make sure you set the AWSAccessKeyID, AWSSecretAccessKey, and BucketName values below.
    
    
    private static String AWSAccessKeyID;
    private static String AWSSecretAccessKey;
    private static String BucketName;
    private static String PolicyDocument;
    private static String PolicyDocumentSignature;

    protected void Page_Load(object sender, EventArgs e)
    {
        AWSAccessKeyID = "";        //** put your value here **
        AWSSecretAccessKey = "";    //** put your value here **
        BucketName = "";            //** put your value here **


        //The following lines check if a CORS configuration exists on your bucket and applies on if it does not. 
        //Comment the following lines if you do not want check and set a configuration.
        if (GetBucketCorsExists() == false)
        {
            SetBucketCors();
        }

                
        DateTime ExpirationDate;
        ExpirationDate = DateTime.UtcNow.AddMinutes(60);

        PolicyDocument = "";
        PolicyDocument += "{";
        PolicyDocument += "  \"expiration\": \"" + ExpirationDate.ToString("s") + ".000Z\",";
        PolicyDocument += "  \"conditions\": [";
        PolicyDocument += "    {\"bucket\": \"" + BucketName + "\"},";
        PolicyDocument += "    {\"acl\": \"public-read\"},";
        PolicyDocument += "    {\"success_action_status\": \"201\"},";
        //PolicyDocument += "    [\"starts-with\", \"$Content-Type\", \"image/\"],";
        PolicyDocument += "    [\"starts-with\", \"$Filename\", \"\"],";
        PolicyDocument += "    [\"starts-with\", \"$name\", \"\"],";
        PolicyDocument += "    [\"starts-with\", \"$key\", \"\"],";
        PolicyDocument += "  ]";
        PolicyDocument += "}";

        Byte[] ByteArray;
        ByteArray = System.Text.Encoding.UTF8.GetBytes(PolicyDocument);

        PolicyDocument = System.Convert.ToBase64String(ByteArray);

        ByteArray = System.Text.Encoding.UTF8.GetBytes(AWSSecretAccessKey);

        System.Security.Cryptography.HMACSHA1 MyHMACSHA1 = new System.Security.Cryptography.HMACSHA1(ByteArray);

        ByteArray = System.Text.Encoding.UTF8.GetBytes(PolicyDocument);

        Byte[] HashArray;
        HashArray = MyHMACSHA1.ComputeHash(ByteArray);

        PolicyDocumentSignature = System.Convert.ToBase64String(HashArray);

    }


    private static Boolean GetBucketCorsExists()
    {
        String RequestURL;
        String RequestMethod;
        System.Collections.Generic.Dictionary<String, String> ExtraRequestHeaders;
        String AuthorizationValue;
        SprightlySoftAWS.REST MyREST = new SprightlySoftAWS.REST();
        Boolean RetBool;
        String PostData;

        int ErrorNumber = 0;
        String ErrorDescription = "";
        String LogData = "";
        System.Collections.Generic.Dictionary<String, String> FullRequestHeaders = new System.Collections.Generic.Dictionary<String, String>();
        int ResponseStatusCode = 0;
        String ResponseStatusDescription = "";
        System.Collections.Generic.Dictionary<String, String> FullResponseHeaders = new System.Collections.Generic.Dictionary<String, String>();
        String ResponseString = "";

        RequestURL = MyREST.BuildS3RequestURL(true, "s3.amazonaws.com", BucketName, "", "?cors");
        RequestMethod = "GET";
        PostData = "";

        ExtraRequestHeaders = new System.Collections.Generic.Dictionary<String, String>();
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"));

        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, AWSAccessKeyID, AWSSecretAccessKey);
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue);

        RetBool = MakeAWSRequest(RequestURL, RequestMethod, ExtraRequestHeaders, PostData, ref ErrorNumber, ref ErrorDescription, ref LogData, ref FullRequestHeaders, ref ResponseStatusCode, ref ResponseStatusDescription, ref FullResponseHeaders, ref ResponseString);

        if (ResponseStatusCode == 404)
        {
            return false;
        }
        else if (RetBool == true)
        {
            return true;
        }
        else
        {
            throw new Exception(LogData);
        }
    }

    private static void SetBucketCors()
    {
        String RequestURL;
        String RequestMethod;
        System.Collections.Generic.Dictionary<String, String> ExtraRequestHeaders;
        String AuthorizationValue;
        SprightlySoftAWS.REST MyREST = new SprightlySoftAWS.REST();
        Boolean RetBool;
        String PostData;
        
        int ErrorNumber = 0;
        String ErrorDescription = "";
        String LogData = "";
        System.Collections.Generic.Dictionary<String, String> FullRequestHeaders = new System.Collections.Generic.Dictionary<String, String>();
        int ResponseStatusCode = 0;
        String ResponseStatusDescription = "";
        System.Collections.Generic.Dictionary<String, String> FullResponseHeaders = new System.Collections.Generic.Dictionary<String, String>();
        String ResponseString = "";

        PostData = "";
        PostData += "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
        PostData += "<CORSConfiguration xmlns=\"http://s3.amazonaws.com/doc/2006-03-01/\">";
        PostData += "<CORSRule>";
        PostData += "<AllowedOrigin>*</AllowedOrigin>";
        PostData += "<AllowedMethod>PUT</AllowedMethod>";
        PostData += "<AllowedMethod>POST</AllowedMethod>";
        PostData += "<AllowedMethod>GET</AllowedMethod>";
        PostData += "<AllowedMethod>HEAD</AllowedMethod>";
        PostData += "<MaxAgeSeconds>3000</MaxAgeSeconds>";
        PostData += "<AllowedHeader>*</AllowedHeader>";
        PostData += "</CORSRule>";
        PostData += "</CORSConfiguration>";
        
        RequestURL = MyREST.BuildS3RequestURL(true, "s3.amazonaws.com", BucketName, "", "?cors");
        RequestMethod = "PUT";

        ExtraRequestHeaders = new System.Collections.Generic.Dictionary<String, String>();

        SprightlySoftAWS.S3.CalculateHash MyCalculateHash = new SprightlySoftAWS.S3.CalculateHash();
        String MyMD5;
        MyMD5 = MyCalculateHash.CalculateMD5FromString(PostData);
        ExtraRequestHeaders.Add("Content-MD5", MyMD5);
        
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"));

        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, AWSAccessKeyID, AWSSecretAccessKey);
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue);

        RetBool = MakeAWSRequest(RequestURL, RequestMethod, ExtraRequestHeaders, PostData, ref ErrorNumber, ref ErrorDescription, ref LogData, ref FullRequestHeaders, ref ResponseStatusCode, ref ResponseStatusDescription, ref FullResponseHeaders, ref ResponseString);

        if (RetBool == false)
        {
            throw new Exception(LogData);
        }
    }
        
    private static Boolean MakeAWSRequest(String RequestURL, String RequestMethod, System.Collections.Generic.Dictionary<String, String> UserRequestHeaders, String PostData, ref int ErrorNumber, ref String ErrorDescription, ref String LogData, ref System.Collections.Generic.Dictionary<String, String> FullRequestHeaders, ref int ResponseStatusCode, ref String ResponseStatusDescription, ref System.Collections.Generic.Dictionary<String, String> FullResponseHeaders, ref String ResponseStringFormatted)
    {
        SprightlySoftAWS.REST MyREST = new SprightlySoftAWS.REST();
        Boolean RetBool = true;
        LogData = "";
        int AWSErrorRetries = 5;

        for (int i = 0; i <= AWSErrorRetries; i++)
        {
            LogData += Environment.NewLine;
            LogData += "-Request Started " + DateTime.Now.ToString() + Environment.NewLine;
            LogData += "-RequestURL=" + RequestURL + Environment.NewLine;
            LogData += "-RequestMethod=" + RequestMethod + Environment.NewLine;

            if (UserRequestHeaders != null)
            {
                foreach (System.Collections.Generic.KeyValuePair<String, String> MyKeyValuePair in UserRequestHeaders)
                {
                    LogData += "-RequestHeader=" + MyKeyValuePair.Key + ":" + MyKeyValuePair.Value + Environment.NewLine;
                }
            }
            LogData += "-RequestPostData=" + PostData + Environment.NewLine;

            RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, UserRequestHeaders, PostData);

            LogData += "-Request Complete " + DateTime.Now.ToString() + Environment.NewLine;
            LogData += "-ResponseErrorNumber=" + MyREST.ErrorNumber + Environment.NewLine;
            LogData += "-ResponseErrorDescription=" + MyREST.ErrorDescription + Environment.NewLine;
            LogData += "-ResponseStatusCode=" + MyREST.ResponseStatusCode + Environment.NewLine;
            LogData += "-ResponseStatusDescription=" + MyREST.ResponseStatusDescription + Environment.NewLine;

            if (MyREST.ResponseHeaders != null)
            {
                foreach (System.Collections.Generic.KeyValuePair<String, String> MyKeyValuePair in MyREST.ResponseHeaders)
                {
                    LogData += "-ResponseHeader=" + MyKeyValuePair.Key + ":" + MyKeyValuePair.Value + Environment.NewLine;
                }
            }

            LogData += "-ResponseString=" + MyREST.ResponseString + Environment.NewLine;

            //Set the return values.
            ErrorNumber = MyREST.ErrorNumber;
            ErrorDescription = MyREST.ErrorDescription;
            FullRequestHeaders = MyREST.RequestHeaders;
            ResponseStatusCode = MyREST.ResponseStatusCode;
            ResponseStatusDescription = MyREST.ResponseStatusDescription;
            FullResponseHeaders = MyREST.ResponseHeaders;
            ResponseStringFormatted = MyREST.ResponseStringFormatted;

            if (RetBool == true)
            {
                break;
            }
            else
            {
                if (MyREST.ResponseStatusCode == 500 || MyREST.ResponseStatusCode == 503)
                {
                    //A Service Unavailable response was returned.  Wait and retry.
                    System.Threading.Thread.Sleep(1000 * i * i);
                }
                else if (MyREST.ResponseStatusCode == 0 && MyREST.ErrorNumber == 1003)
                {
                    //Getting the response failed.  This may be a network disconnection.  Wait and retry.
                    System.Threading.Thread.Sleep(1000 * i * i);
                }
                else
                {
                    //An error occured but retrying would not solve the problem.
                    break;
                }
            }
        }

        return RetBool;
    }
    
    
</script>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8"/>
<title>Plupload to Amazon S3 Example</title>

<style type="text/css">
	body {
		font-family:Verdana, Geneva, sans-serif;
		font-size:13px;
		color:#333;
	}
</style>

<link rel="stylesheet" href="/Content/themes/base/all.css" type="text/css" />
<script src="/Scripts/jquery-2.1.4.min.js" type="text/javascript"></script>
<script src="/Scripts/jquery-ui-1.11.4.min.js" type="text/javascript"></script>

<link rel="stylesheet" href="/Scripts/plupload/jquery.ui.plupload/css/jquery.ui.plupload.css" type="text/css" />
<script type="text/javascript" src="/Scripts/plupload/plupload.full.min.js"></script>
<script type="text/javascript" src="/Scripts/plupload/jquery.ui.plupload/jquery.ui.plupload.min.js"></script>

</head>
<body>

<h1>Plupload to Amazon S3 Example</h1>

<div id="runtimediv">No runtime found.</div>
<br />

<div id="uploaderdiv">
    <p>Your browser does not have HTML5, Flash, or Silverlight support.</p>
</div>

<script type="text/javascript">
    // Convert divs to queue widgets when the DOM is ready
    $(function () {
        $("#uploaderdiv").plupload({
            runtimes: 'html5,flash,silverlight',
            url: 'https://<%=BucketName%>.s3.amazonaws.com',
            max_file_size: '50mb',

            multipart: true,
            multipart_params: {
                'key': '${filename}', // use filename as a key
                'Filename': '${filename}', // adding this to keep consistency across the runtimes
                'acl': 'public-read',
                //'Content-Type': 'image/jpeg',
                'success_action_status': '201',
                'AWSAccessKeyId': '<%=AWSAccessKeyID%>',
                'policy': '<%=PolicyDocument%>',
                'signature': '<%=PolicyDocumentSignature%>'
            },

            preinit: {
                Init: function (up, params) {
                    $('#runtimediv').html("<div>Current runtime: " + params.runtime + "</div>");
                }
            },

            // !!!Important!!! 
            // this is not recommended with S3, since it will force Flash runtime into the mode, with no progress indication
            //resize : {width : 800, height : 600, quality : 60},  // Resize images on clientside, if possible 

            // optional, but better be specified directly
            file_data_name: 'file',

            // re-use widget (not related to S3, but to Plupload UI Widget)
            multiple_queues: true,

            // Specify what files to browse for
            //filters : [
            //	{title : "JPEG files", extensions : "jpg"}
            //],

            // Flash settings
            flash_swf_url: '/Scripts/plupload/Moxie.swf',

            // Silverlight settings
            silverlight_xap_url: '/Scripts/plupload/Moxie.xap'
        });
    });
</script>

</body>
</html>
