﻿Imports System.Windows.Forms

Public Class FormBrowse

    Dim WithEvents MyREST As SprightlySoftAWS.REST
    Dim WithEvents MyListBucket As SprightlySoftAWS.S3.ListBucket
    Dim WithEvents PopulateDeleteQueueListBucket As SprightlySoftAWS.S3.ListBucket

    Dim WithEvents ListBucketsBackgroundWorker As System.ComponentModel.BackgroundWorker
    Dim WithEvents ListBucketBackgroundWorker As System.ComponentModel.BackgroundWorker
    Dim WithEvents PopulateDeleteQueueBackgroundWorker As System.ComponentModel.BackgroundWorker
    Dim WithEvents DeleteItemBackgroundWorker As System.ComponentModel.BackgroundWorker

    Dim ListViewAmazonSortColumn As Integer = 0
    Dim Marker As String
    Dim MySmallImageList As ImageList
    Dim DeleteQueueArrayList As ArrayList
    Dim DeleteQueueKeepGoing As Boolean

    Public CurrentBucketName As String = ""
    Public CurrentPath As String = ""
    Public Delimiter As String = "/"


    Private Sub FormBrowse_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        MyREST = New SprightlySoftAWS.REST
        MyListBucket = New SprightlySoftAWS.S3.ListBucket
        PopulateDeleteQueueListBucket = New SprightlySoftAWS.S3.ListBucket

        ListBucketsBackgroundWorker = New System.ComponentModel.BackgroundWorker
        ListBucketBackgroundWorker = New System.ComponentModel.BackgroundWorker
        PopulateDeleteQueueBackgroundWorker = New System.ComponentModel.BackgroundWorker
        DeleteItemBackgroundWorker = New System.ComponentModel.BackgroundWorker

        ToolStripStatusLabelAction.Text = ""
        ToolStripStatusLabelSummary.Text = ""

        ListViewAmazon.Sorting = SortOrder.Ascending

        ListPath()
    End Sub


    Private Sub ListViewAmazon_ColumnClick(ByVal sender As Object, ByVal e As System.Windows.Forms.ColumnClickEventArgs) Handles ListViewAmazon.ColumnClick
        'Sorting ListView Items: http://msdn.microsoft.com/en-us/library/ms996467.aspx

        ToolStripStatusLabelAction.Text = "Sorting...."
        Application.DoEvents()

        If e.Column <> ListViewAmazonSortColumn Then
            ListViewAmazonSortColumn = e.Column
            ListViewAmazon.Sorting = SortOrder.Ascending
        Else
            If ListViewAmazon.Sorting = SortOrder.Ascending Then
                ListViewAmazon.Sorting = SortOrder.Descending
            Else
                ListViewAmazon.Sorting = SortOrder.Ascending
            End If
        End If

        ListViewAmazon.Sort()
        ListViewAmazon.ListViewItemSorter = New ListViewItemComparer(e.Column, ListViewAmazon.Sorting)

        ToolStripStatusLabelAction.Text = ""

    End Sub


    Private Sub ListViewAmazon_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListViewAmazon.DoubleClick

        If ListViewAmazon.SelectedItems(0).Tag.IsBucket = True Then
            'a bucket was clicked
            CurrentBucketName = ListViewAmazon.SelectedItems(0).Tag.BucketName
            CurrentPath = ""
            ListPath()
        ElseIf ListViewAmazon.SelectedItems(0).Tag.IsFolder = True Then
            'a folder was clicked
            CurrentPath = ListViewAmazon.SelectedItems(0).Tag.KeyName
            ListPath()
        End If

    End Sub


    Private Sub ToolStripButtonGoUp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonGoUp.Click
        If InStr(CurrentPath, Delimiter) > 0 Then
            'remove the last folder from the path
            CurrentPath = Microsoft.VisualBasic.Left(CurrentPath, Len(CurrentPath) - Len(Delimiter))
            CurrentPath = Microsoft.VisualBasic.Left(CurrentPath, InStrRev(CurrentPath, Delimiter))
            ListPath()
        ElseIf CurrentPath = "" Then
            'if there is no path, list all buckets
            CurrentBucketName = ""
            ListPath()
        End If
    End Sub


    Private Sub ToolStripButtonRefresh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonRefresh.Click
        ListPath()
    End Sub

    Private Sub ListPath()

        'Amazon S3 Keys: http://docs.amazonwebservices.com/AmazonS3/latest/UsingKeys.html

        ToolStripTextBoxPath.Text = Delimiter & CurrentBucketName
        If CurrentPath <> "" Then
            ToolStripTextBoxPath.Text = ToolStripTextBoxPath.Text & Delimiter & CurrentPath
        End If

        If CurrentBucketName = "" Then
            'list all buckets
            ListBuckets()
        Else
            'list the path
            ListBucket()
        End If

    End Sub


    Private Sub EnableDisableStart()

        'remove the item sorter so items are not sorted when added.  This will make listing large buckets quicker
        ListViewAmazon.ListViewItemSorter = Nothing

        ListViewAmazon.Clear()

        If CurrentBucketName = "" Then
            'set the column headers for listing buckets
            Dim MyColumnHeader As ColumnHeader
            MyColumnHeader = New ColumnHeader
            MyColumnHeader.Text = "Name"
            If My.Settings.BucketsCol0Width > 20 Then
                MyColumnHeader.Width = My.Settings.BucketsCol0Width
            Else
                MyColumnHeader.Width = 250
            End If
            ListViewAmazon.Columns.Add(MyColumnHeader)

            MyColumnHeader = New ColumnHeader
            MyColumnHeader.Text = "Date Created"
            If My.Settings.BucketsCol1Width > 20 Then
                MyColumnHeader.Width = My.Settings.BucketsCol1Width
            Else
                MyColumnHeader.Width = 140
            End If
            ListViewAmazon.Columns.Add(MyColumnHeader)
        Else
            'set the column headers for listing a bucket
            Dim MyColumnHeader As ColumnHeader
            MyColumnHeader = New ColumnHeader
            MyColumnHeader.Text = "Name"
            If My.Settings.BucketCol0Width > 20 Then
                MyColumnHeader.Width = My.Settings.BucketCol0Width
            Else
                MyColumnHeader.Width = 250
            End If
            ListViewAmazon.Columns.Add(MyColumnHeader)

            MyColumnHeader = New ColumnHeader
            MyColumnHeader.Text = "Size"
            If My.Settings.BucketCol1Width > 20 Then
                MyColumnHeader.Width = My.Settings.BucketCol1Width
            Else
                MyColumnHeader.Width = 75
            End If
            ListViewAmazon.Columns.Add(MyColumnHeader)

            MyColumnHeader = New ColumnHeader
            MyColumnHeader.Text = "Last Modified"
            If My.Settings.BucketCol2Width > 20 Then
                MyColumnHeader.Width = My.Settings.BucketCol2Width
            Else
                MyColumnHeader.Width = 140
            End If
            ListViewAmazon.Columns.Add(MyColumnHeader)

            MyColumnHeader = New ColumnHeader
            MyColumnHeader.Text = "Type"
            If My.Settings.BucketCol3Width > 20 Then
                MyColumnHeader.Width = My.Settings.BucketCol3Width
            Else
                MyColumnHeader.Width = 140
            End If
            ListViewAmazon.Columns.Add(MyColumnHeader)
        End If

        'do not allow sorting by clicking a column header while listing is taking place
        ListViewAmazon.HeaderStyle = ColumnHeaderStyle.Nonclickable

        ToolStripPath.Enabled = False
        ToolStripButtons.Enabled = False
    End Sub


    Private Sub EnableDisableEnd(Optional ByVal SortListView As Boolean = True)

        If SortListView = True Then
            ToolStripStatusLabelAction.Text = "Sorting...."
            Application.DoEvents()
            ListViewAmazon.Sort()
            ListViewAmazon.ListViewItemSorter = New ListViewItemComparer(ListViewAmazonSortColumn, ListViewAmazon.Sorting)
        End If

        ToolStripPath.Enabled = True
        ToolStripButtons.Enabled = True
        ListViewAmazon.HeaderStyle = ColumnHeaderStyle.Clickable
        ToolStripStatusLabelAction.Text = ""
        ToolStripStatusLabelSummary.Text = FormatNumber(ListViewAmazon.Items.Count, 0) & " items"

    End Sub


    Private Sub ListBuckets()

        EnableDisableStart()

        'GET Service: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTServiceGET.html

        MySmallImageList = New ImageList
        MySmallImageList.ColorDepth = ColorDepth.Depth16Bit
        ListViewAmazon.SmallImageList = MySmallImageList

        ToolStripStatusLabelAction.Text = "Listing...."
        ToolStripStatusLabelSummary.Text = ""


        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", "", "", "")

        Dim RequestMethod As String = "GET"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, FormMain.TextBoxAWSAccessKeyId.Text, FormMain.TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)


        Dim MyHashTable As New Hashtable
        MyHashTable.Add("RequestURL", RequestURL)
        MyHashTable.Add("RequestMethod", RequestMethod)
        MyHashTable.Add("ExtraRequestHeaders", ExtraRequestHeaders)

        ListBucketsBackgroundWorker.RunWorkerAsync(MyHashTable)

    End Sub


    Private Sub ListBucketsBackgroundWorker_DoWork(ByVal sender As System.Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles ListBucketsBackgroundWorker.DoWork
        e.Result = MyREST.MakeRequest(e.Argument("RequestURL"), e.Argument("RequestMethod"), e.Argument("ExtraRequestHeaders"))
    End Sub


    Private Sub ListBucketsBackgroundWorker_RunWorkerCompleted(ByVal sender As Object, ByVal e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles ListBucketsBackgroundWorker.RunWorkerCompleted

        'print the log data to the Output window
        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        'initalize the image list that will store icons for the list view items
        Dim MySmallImageList As New ImageList
        MySmallImageList.ColorDepth = ColorDepth.Depth16Bit
        ListViewAmazon.SmallImageList = MySmallImageList

        Dim MyItemObject As ItemObject
        Dim MyListViewItem As ListViewItem
        Dim MyHelper As New SprightlySoftAWS.S3.Helper
        Dim MyBitmap As Bitmap

        Dim BucketName As String
        Dim BucketDate As Date
        Dim OwnerID As String
        Dim OwnerName As String

        Dim XmlDoc As System.Xml.XmlDocument
        Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
        Dim XmlNode As System.Xml.XmlNode
        Dim XmlContentsNodeList As System.Xml.XmlNodeList
        Dim ResponseMessage As String = ""

        'check if the result of the operation was successful
        If e.Result = True Then

            ToolStripStatusLabelAction.Text = "Processing XML...."
            ListViewAmazon.BeginUpdate()

            'load the response XML from Amazon into an XmlDocument
            XmlDoc = New System.Xml.XmlDocument
            XmlDoc.LoadXml(MyREST.ResponseString)

            'specify the namespace for XML path expressions
            MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(XmlDoc.NameTable)
            MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

            'extract all values from the response XML
            XmlNode = XmlDoc.SelectSingleNode("/amz:ListAllMyBucketsResult/amz:Owner/amz:ID", MyXmlNamespaceManager)
            OwnerID = XmlNode.InnerText

            XmlNode = XmlDoc.SelectSingleNode("/amz:ListAllMyBucketsResult/amz:Owner/amz:DisplayName", MyXmlNamespaceManager)
            OwnerName = XmlNode.InnerText

            XmlContentsNodeList = XmlDoc.SelectNodes("/amz:ListAllMyBucketsResult/amz:Buckets/amz:Bucket", MyXmlNamespaceManager)

            For Each XmlContentsNode As System.Xml.XmlNode In XmlContentsNodeList

                XmlNode = XmlContentsNode.SelectSingleNode("./amz:Name", MyXmlNamespaceManager)
                BucketName = XmlNode.InnerText

                XmlNode = XmlContentsNode.SelectSingleNode("./amz:CreationDate", MyXmlNamespaceManager)
                BucketDate = CDate(XmlNode.InnerText)

                MyItemObject = New ItemObject
                MyItemObject.IsBucket = True
                MyItemObject.IsFolder = False
                MyItemObject.BucketName = BucketName
                MyItemObject.KeyName = ""
                MyItemObject.DisplayName = BucketName
                MyItemObject.Size = -1
                MyItemObject.Date = BucketDate
                MyItemObject.FileType = ""
                MyItemObject.ETag = ""
                MyItemObject.OwnerID = OwnerID
                MyItemObject.OwnerName = OwnerName
                MyItemObject.SortName = BucketName
                MyItemObject.SortDate = BucketDate
                MyItemObject.SortFileType = ""

                If MySmallImageList.Images.ContainsKey("bucket") = False Then
                    MyBitmap = MyHelper.GetIconByPath(System.IO.Path.GetTempPath, True)  'use a folder icon for the bucket.  Call GetIconByPath and pass any folder name
                    MySmallImageList.Images.Add("bucket", MyBitmap)
                End If

                MyListViewItem = New ListViewItem(BucketName)
                MyListViewItem.SubItems.Add(BucketDate)
                MyListViewItem.ImageKey = "bucket"
                MyListViewItem.Tag = MyItemObject
                ListViewAmazon.Items.Add(MyListViewItem)

            Next

            ListViewAmazon.EndUpdate()

            EnableDisableEnd()

        Else

            If MyREST.ResponseString = "" Then
                ResponseMessage = MyREST.ErrorDescription
            Else
                XmlDoc = New System.Xml.XmlDocument
                XmlDoc.LoadXml(MyREST.ResponseString)

                XmlNode = XmlDoc.SelectSingleNode("/Error/Message")

                ResponseMessage = XmlNode.InnerText
            End If

            EnableDisableEnd(False)  'do not sort the list box after an error.  It may take a while if there are many items

            MessageBox.Show(ResponseMessage, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

        End If

    End Sub


    Private Sub ListBucket()

        EnableDisableStart()

        MySmallImageList = New ImageList
        MySmallImageList.ColorDepth = ColorDepth.Depth16Bit
        ListViewAmazon.SmallImageList = MySmallImageList

        ToolStripStatusLabelAction.Text = "Listing...."
        ToolStripStatusLabelSummary.Text = ""

        Dim MyHashTable As New Hashtable
        MyHashTable.Add("UseSSL", True)
        MyHashTable.Add("RequestEndpoint", "s3.amazonaws.com")
        MyHashTable.Add("BucketName", CurrentBucketName)
        MyHashTable.Add("Delimiter", Delimiter)
        MyHashTable.Add("Prefix", CurrentPath)
        MyHashTable.Add("AWSAccessKeyId", FormMain.TextBoxAWSAccessKeyId.Text)
        MyHashTable.Add("AWSSecretAccessKey", FormMain.TextBoxAWSSecretAccessKey.Text)

        ListBucketBackgroundWorker.RunWorkerAsync(MyHashTable)

    End Sub


    Private Sub ListBucketBackgroundWorker_DoWork(ByVal sender As System.Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles ListBucketBackgroundWorker.DoWork
        e.Result = MyListBucket.ListBucket(e.Argument("UseSSL"), e.Argument("RequestEndpoint"), e.Argument("BucketName"), e.Argument("Delimiter"), e.Argument("Prefix"), e.Argument("AWSAccessKeyId"), e.Argument("AWSSecretAccessKey"))
    End Sub


    Private Sub MyListBucket_ProgressChangedEvent() Handles MyListBucket.ProgressChangedEvent

        'The ListBucket function list all items in a bucket.  Every time page is complete (1000 items)
        'the  ProgressChangedEvent is fired.  You can access the BucketItemsArrayList property
        'of the ListBucket class and add any new items to the ListView

        If Me.InvokeRequired = True Then
            Me.Invoke(New MethodInvoker(AddressOf MyListBucket_ProgressChangedEvent))
        Else

            Dim MyItemObject As ItemObject
            Dim MyBucketItemObject As SprightlySoftAWS.S3.ListBucket.BucketItemObject
            Dim MyListViewItem As ListViewItem
            Dim MyHelper As New SprightlySoftAWS.S3.Helper

            Dim MyBitmap As Bitmap
            Dim FileExtension As String = ""
            Dim FileType As String

            ToolStripStatusLabelAction.Text = "Processing items...."
            ListViewAmazon.BeginUpdate()

            For i As Integer = ListViewAmazon.Items.Count To MyListBucket.BucketItemsArrayList.Count - 1

                MyBucketItemObject = MyListBucket.BucketItemsArrayList(i)

                MyItemObject = New ItemObject

                If MyBucketItemObject.IsFolder = True Then

                    FileType = MyHelper.GetDisplayTypeForFolder()

                    MyItemObject.IsBucket = False
                    MyItemObject.IsFolder = True
                    MyItemObject.BucketName = MyBucketItemObject.BucketName
                    MyItemObject.KeyName = MyBucketItemObject.KeyName
                    MyItemObject.DisplayName = MyBucketItemObject.DisplayName
                    MyItemObject.Size = MyBucketItemObject.Size
                    MyItemObject.Date = MyBucketItemObject.LastModified
                    MyItemObject.FileType = FileType
                    MyItemObject.ETag = MyBucketItemObject.ETag
                    MyItemObject.OwnerID = MyBucketItemObject.OwnerID
                    MyItemObject.OwnerName = MyBucketItemObject.OwnerName
                    MyItemObject.SortName = " " & MyBucketItemObject.DisplayName  'prefix with a space so when ordered it's at the top
                    MyItemObject.SortDate = MyBucketItemObject.LastModified
                    MyItemObject.SortFileType = " " & FileType

                    If MySmallImageList.Images.ContainsKey("folder") = False Then
                        MyBitmap = MyHelper.GetIconByPath(System.IO.Path.GetTempPath, True)  'use a folder icon for the bucket.  Call GetIconByPath and pass any folder name
                        MySmallImageList.Images.Add("folder", MyBitmap)
                    End If

                    MyListViewItem = New ListViewItem(MyBucketItemObject.DisplayName)
                    MyListViewItem.SubItems.Add("")  'do not show the size for a folder
                    MyListViewItem.SubItems.Add("")  'do not show the date for a folder
                    MyListViewItem.SubItems.Add(FileType)
                    MyListViewItem.ImageKey = "folder"
                    MyListViewItem.Tag = MyItemObject
                    ListViewAmazon.Items.Add(MyListViewItem)

                Else

                    Try
                        FileType = MyHelper.GetDisplayTypeForFile(System.IO.Path.GetExtension(MyBucketItemObject.DisplayName))
                    Catch ex As Exception
                        FileType = ""
                    End Try

                    MyItemObject.IsBucket = False
                    MyItemObject.IsFolder = MyBucketItemObject.IsFolder
                    MyItemObject.BucketName = MyBucketItemObject.BucketName
                    MyItemObject.KeyName = MyBucketItemObject.KeyName
                    MyItemObject.DisplayName = MyBucketItemObject.DisplayName
                    MyItemObject.Size = MyBucketItemObject.Size
                    MyItemObject.Date = MyBucketItemObject.LastModified
                    MyItemObject.FileType = FileType
                    MyItemObject.ETag = MyBucketItemObject.ETag
                    MyItemObject.OwnerID = MyBucketItemObject.OwnerID
                    MyItemObject.OwnerName = MyBucketItemObject.OwnerName
                    MyItemObject.SortName = MyBucketItemObject.DisplayName
                    MyItemObject.SortDate = MyBucketItemObject.LastModified
                    MyItemObject.SortFileType = FileType


                    Try
                        FileExtension = LCase(System.IO.Path.GetExtension(MyBucketItemObject.DisplayName))
                    Catch ex As Exception
                        FileExtension = ""
                    End Try

                    If FileExtension = "" Then
                        'a value is required for the FileExtension.  Hard code a value if none exists.
                        FileExtension = ".noextension"
                    ElseIf Len(FileExtension) > 5 Then
                        'use the default file icon if the extension name is too long.  This will prevent the image list form being filled with too many icons for nonsense extensions
                        FileExtension = ".noextension"
                    End If

                    'only add the icon to the ImageList is it does not exist in the ImageList
                    If MySmallImageList.Images.ContainsKey(FileExtension) = False Then
                        MyBitmap = MyHelper.GetIconByExtension(FileExtension, True)
                        If IsNothing(MyBitmap) = False Then
                            MySmallImageList.Images.Add(FileExtension, MyBitmap)
                        End If
                    End If


                    MyListViewItem = New ListViewItem(MyBucketItemObject.DisplayName)
                    MyListViewItem.SubItems.Add(MyHelper.FormatByteSize(MyBucketItemObject.Size))
                    MyListViewItem.SubItems.Add(MyBucketItemObject.LastModified)
                    MyListViewItem.SubItems.Add(FileType)
                    MyListViewItem.ImageKey = FileExtension
                    MyListViewItem.Tag = MyItemObject
                    ListViewAmazon.Items.Add(MyListViewItem)

                End If

            Next

            ListViewAmazon.EndUpdate()

            ToolStripStatusLabelAction.Text = "Listing...."
            ToolStripStatusLabelSummary.Text = FormatNumber(ListViewAmazon.Items.Count, 0) & " items"

        End If

    End Sub


    Private Sub ListBucketBackgroundWorker_RunWorkerCompleted(ByVal sender As Object, ByVal e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles ListBucketBackgroundWorker.RunWorkerCompleted

        Debug.Print("")
        Debug.Print(MyListBucket.LogData)
        Debug.Print("")

        If e.Result = True Then
            EnableDisableEnd()
        Else

            Dim ResponseMessage As String
            Dim XmlDoc As System.Xml.XmlDocument
            Dim XmlNode As System.Xml.XmlNode

            If MyListBucket.ResponseString = "" Then
                ResponseMessage = MyListBucket.ErrorDescription
            Else
                XmlDoc = New System.Xml.XmlDocument
                XmlDoc.LoadXml(MyListBucket.ResponseString)

                XmlNode = XmlDoc.SelectSingleNode("/Error/Message")

                ResponseMessage = XmlNode.InnerText
            End If

            EnableDisableEnd(False)  'do not sort the list box after an error.  It may take a while if there are many items

            MessageBox.Show(ResponseMessage, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

        End If

    End Sub


    Private Sub ListViewAmazon_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles ListViewAmazon.KeyDown

        If e.KeyCode = Keys.A And Control.ModifierKeys = Keys.Control Then  'Ctrl-A  select all items
            For Each MyListViewItem As ListViewItem In ListViewAmazon.Items
                MyListViewItem.Selected = True
            Next

        ElseIf e.KeyCode = Keys.F5 Then  'refresh the current path
            ListPath()

        ElseIf e.KeyCode = Keys.Delete Then  'delete the selected items
            DeleteItems()

        ElseIf e.KeyCode = Keys.Escape Then  'abort the listing of a bucket or buckets
            If MyREST.State = 1 Then
                MyREST.Abort()
            ElseIf MyListBucket.State = 1 Then
                MyListBucket.Abort()
            End If

        ElseIf e.KeyCode = Keys.Enter Then  'enter the selected bucket or folder
            If ListViewAmazon.SelectedItems.Count = 1 Then
                If ListViewAmazon.SelectedItems(0).Tag.IsBucket = True Then
                    CurrentBucketName = ListViewAmazon.SelectedItems(0).Tag.BucketName
                    CurrentPath = ""
                    ListPath()
                ElseIf ListViewAmazon.SelectedItems(0).Tag.IsFolder = True Then
                    CurrentPath = ListViewAmazon.SelectedItems(0).Tag.KeyName
                    ListPath()
                End If
            End If

        ElseIf e.KeyCode = Keys.Back Then  'go up one level
            If InStr(CurrentPath, Delimiter) > 0 Then
                'remove the last folder from the path
                CurrentPath = Microsoft.VisualBasic.Left(CurrentPath, Len(CurrentPath) - Len(Delimiter))
                CurrentPath = Microsoft.VisualBasic.Left(CurrentPath, InStrRev(CurrentPath, Delimiter))
                ListPath()
            ElseIf CurrentPath = "" Then
                'if there is no path, list all buckets
                CurrentBucketName = ""
                ListPath()
            End If
        End If

    End Sub


    Private Sub ListViewAmazon_ColumnWidthChanged(ByVal sender As Object, ByVal e As System.Windows.Forms.ColumnWidthChangedEventArgs) Handles ListViewAmazon.ColumnWidthChanged
        If CurrentBucketName = "" Then
            If ListViewAmazon.Columns.Count = 2 Then  'only save the width if all columns are displayed
                My.Settings.BucketsCol0Width = ListViewAmazon.Columns(0).Width
                My.Settings.BucketsCol1Width = ListViewAmazon.Columns(1).Width
            End If
        Else
            If ListViewAmazon.Columns.Count = 4 Then  'only save the width if all columns are displayed
                My.Settings.BucketCol0Width = ListViewAmazon.Columns(0).Width
                My.Settings.BucketCol1Width = ListViewAmazon.Columns(1).Width
                My.Settings.BucketCol2Width = ListViewAmazon.Columns(2).Width
                My.Settings.BucketCol3Width = ListViewAmazon.Columns(3).Width
            End If
        End If
    End Sub


    Private Sub FormBrowse_ResizeEnd(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ResizeEnd
        My.Settings.FormBrowseHeight = Me.Height
        My.Settings.FormBrowseWidth = Me.Width
    End Sub


    Private Sub ToolStripButtonNewFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonNewFolder.Click

        If CurrentBucketName = "" Then
            'make sure the user is in a bucket
            MessageBox.Show("A folder can only be created in a bucket.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

        ElseIf Delimiter = "" Then
            'a folder can only be created in folder view mode
            MessageBox.Show("A folder can only be created when a delimiter (folder view) is being used.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

        Else

            'get the new folder name
            Dim NewFolderName As String
            NewFolderName = InputBox("Enter the name of the new folder.", "New Folder")

            Dim NewKeyName As String
            NewKeyName = CurrentPath & NewFolderName & Delimiter


            If NewFolderName = "" Then
                'the user did not enter a folder name, do nothing

            ElseIf InStr(NewFolderName, Delimiter) > 0 Then
                MessageBox.Show("The folder name cannot contain the delimiter character (" & Delimiter & ").", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

            Else
                'check if the folder already exists
                Dim RequestURL As String
                RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", CurrentBucketName, NewKeyName, "")

                Dim RequestMethod As String = "HEAD"

                Dim ExtraRequestHeaders As New Dictionary(Of String, String)
                ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

                Dim AuthorizationValue As String
                AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, FormMain.TextBoxAWSAccessKeyId.Text, FormMain.TextBoxAWSSecretAccessKey.Text)
                ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

                Dim RetBool As Boolean
                RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

                If MyREST.ResponseStatusCode = 404 Then

                    Dim PutXML As String
                    PutXML = ""  'creating a folder is like uploading a file.  The folder object will be an empty file

                    RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", CurrentBucketName, NewKeyName, "")

                    RequestMethod = "PUT"

                    ExtraRequestHeaders = New Dictionary(Of String, String)
                    ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

                    AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, FormMain.TextBoxAWSAccessKeyId.Text, FormMain.TextBoxAWSSecretAccessKey.Text)
                    ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

                    RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, PutXML)

                    Debug.Print("")
                    Debug.Print(MyREST.LogData)
                    Debug.Print("")

                    If RetBool = True Then
                        'the folder was created.  Relist the path to see the new folder
                        ListPath()
                    Else

                        Dim ResponseMessage As String

                        If MyREST.ResponseString = "" Then
                            ResponseMessage = MyREST.ErrorDescription
                        Else
                            Dim XmlDoc As System.Xml.XmlDocument
                            Dim XmlNode As System.Xml.XmlNode

                            XmlDoc = New System.Xml.XmlDocument
                            XmlDoc.LoadXml(MyREST.ResponseString)

                            XmlNode = XmlDoc.SelectSingleNode("/Error/Message")

                            ResponseMessage = XmlNode.InnerText
                        End If

                        MessageBox.Show(ResponseMessage, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

                    End If

                Else
                    MessageBox.Show("The folder already exists.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

                End If

            End If

        End If

    End Sub


    Private Sub ToolStripButtonDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonDelete.Click
        DeleteItems()
    End Sub


    Private Sub DeleteItems()

        If ListViewAmazon.SelectedItems.Count > 0 Then

            Dim MyDialogResult As System.Windows.Forms.DialogResult
            If ListViewAmazon.SelectedItems.Count = 1 Then
                MyDialogResult = MessageBox.Show("Are you sure you would like to permanently delete " & ListViewAmazon.SelectedItems(0).Tag.DisplayName & "?", "Delete Item", MessageBoxButtons.YesNo, MessageBoxIcon.Question)
            Else
                MyDialogResult = MessageBox.Show("Are you sure you would like to permanently delete the " & ListViewAmazon.SelectedItems.Count & " selected items?", "Delete Items", MessageBoxButtons.YesNo, MessageBoxIcon.Question)
            End If


            If MyDialogResult = Windows.Forms.DialogResult.Yes Then

                DeleteQueueArrayList = New ArrayList
                DeleteQueueKeepGoing = True

                'add each selected item to the DeleteQueueArrayList
                For Each MyListViewItem As ListViewItem In ListViewAmazon.SelectedItems
                    DeleteQueueArrayList.Add(MyListViewItem.Tag)
                Next


                ToolStripStatusLabelAction.Text = "Getting items to delete " & FormatNumber(DeleteQueueArrayList.Count, 0) & "...."
                ListViewAmazon.Enabled = False
                ToolStripButtonGoUp.Enabled = False
                ToolStripButtonRefresh.Enabled = False
                ToolStripButtonDelete.Enabled = False
                ToolStripButtonNewFolder.Enabled = False
                ToolStripButtonAbort.Visible = True


                'In a background worker go through the ArrayList and add each item in each folder to the ArrayList.
                'Amazon does not have a feature to recursively delete a folder.  Each item must be deleted individually.
                Dim MyHashTable As New Hashtable
                MyHashTable.Add("UseSSL", True)
                MyHashTable.Add("RequestEndpoint", "s3.amazonaws.com")
                MyHashTable.Add("AWSAccessKeyId", FormMain.TextBoxAWSAccessKeyId.Text)
                MyHashTable.Add("AWSSecretAccessKey", FormMain.TextBoxAWSSecretAccessKey.Text)
                MyHashTable.Add("DeleteQueueArrayList", DeleteQueueArrayList)

                PopulateDeleteQueueBackgroundWorker.RunWorkerAsync(MyHashTable)

            End If

        End If

    End Sub


    Private Sub PopulateDeleteQueueBackgroundWorker_DoWork(ByVal sender As System.Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles PopulateDeleteQueueBackgroundWorker.DoWork

        Dim MyArrayList As ArrayList
        MyArrayList = e.Argument("DeleteQueueArrayList")

        Dim RetBool As Boolean = True

        For i As Integer = 0 To MyArrayList.Count - 1

            'if the item is a folder, add each item in the folder to the delete queue
            If MyArrayList(i).IsFolder = True Then

                'call ListBucket with no delimiter to get a recursive list of all items in the folder
                RetBool = PopulateDeleteQueueListBucket.ListBucket(e.Argument("UseSSL"), e.Argument("RequestEndpoint"), MyArrayList(i).BucketName, "", MyArrayList(i).KeyName, e.Argument("AWSAccessKeyId"), e.Argument("AWSSecretAccessKey"))

                If RetBool = True Then

                    For Each MyBucketItemObject As SprightlySoftAWS.S3.ListBucket.BucketItemObject In PopulateDeleteQueueListBucket.BucketItemsArrayList
                        MyArrayList.Add(MyBucketItemObject)
                    Next

                Else
                    'if an error occurs, exit
                    Exit For
                End If

            End If

            If DeleteQueueKeepGoing = False Then
                Exit For
            End If

        Next


        Dim MyHashTable As New Hashtable

        If DeleteQueueKeepGoing = False Then
            MyHashTable.Add("RetBool", False)
            MyHashTable.Add("ResponseXML", "")
            MyHashTable.Add("ErrorNumber", 1172)
            MyHashTable.Add("ErrorDescription", "The operation was aborted.")
            MyHashTable.Add("DeleteQueueArrayList", MyArrayList)
        Else
            MyHashTable.Add("RetBool", RetBool)
            MyHashTable.Add("ResponseXML", PopulateDeleteQueueListBucket.ResponseString)
            MyHashTable.Add("ErrorNumber", PopulateDeleteQueueListBucket.ErrorNumber)
            MyHashTable.Add("ErrorDescription", PopulateDeleteQueueListBucket.ErrorDescription)
            MyHashTable.Add("DeleteQueueArrayList", MyArrayList)
        End If

        e.Result = MyHashTable

    End Sub


    Private Sub PopulateDeleteQueueListBucket_ProgressChangedEvent() Handles PopulateDeleteQueueListBucket.ProgressChangedEvent
        'update the status bar while listing a folder that has thousands of items
        If Me.InvokeRequired = True Then
            Me.Invoke(New MethodInvoker(AddressOf PopulateDeleteQueueListBucket_ProgressChangedEvent))
        Else
            ToolStripStatusLabelAction.Text = "Getting items to delete " & FormatNumber(DeleteQueueArrayList.Count + PopulateDeleteQueueListBucket.BucketItemsArrayList.Count, 0) & "...."
        End If

    End Sub


    Private Sub PopulateDeleteQueueBackgroundWorker_RunWorkerCompleted(ByVal sender As Object, ByVal e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles PopulateDeleteQueueBackgroundWorker.RunWorkerCompleted

        If e.Result("RetBool") = True Then

            DeleteQueueArrayList = e.Result("DeleteQueueArrayList")

            ToolStripStatusLabelAction.Text = "Deleting " & DeleteQueueArrayList(DeleteQueueArrayList.Count - 1).KeyName & ", " & FormatNumber(DeleteQueueArrayList.Count, 0) & " items remaining...."

            Dim RequestURL As String
            RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", DeleteQueueArrayList(DeleteQueueArrayList.Count - 1).BucketName, DeleteQueueArrayList(DeleteQueueArrayList.Count - 1).KeyName, "")

            Dim RequestMethod As String = "DELETE"

            Dim ExtraRequestHeaders As New Dictionary(Of String, String)
            ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

            Dim AuthorizationValue As String
            AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, FormMain.TextBoxAWSAccessKeyId.Text, FormMain.TextBoxAWSSecretAccessKey.Text)
            ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

            'delete the last item in the array list first so items in a folder are deleted before the folder itself
            Dim MyHashTable As New Hashtable
            MyHashTable.Add("RequestURL", RequestURL)
            MyHashTable.Add("RequestMethod", RequestMethod)
            MyHashTable.Add("ExtraRequestHeaders", ExtraRequestHeaders)

            DeleteItemBackgroundWorker.RunWorkerAsync(MyHashTable)

        Else

            ToolStripStatusLabelAction.Text = ""
            ListViewAmazon.Enabled = True
            ToolStripButtonGoUp.Enabled = True
            ToolStripButtonRefresh.Enabled = True
            ToolStripButtonDelete.Enabled = True
            ToolStripButtonNewFolder.Enabled = True
            ToolStripButtonAbort.Visible = False


            Dim ResponseMessage As String
            Dim XmlDoc As System.Xml.XmlDocument
            Dim XmlNode As System.Xml.XmlNode

            If MyListBucket.ResponseString = "" Then
                ResponseMessage = e.Result("ErrorDescription")
            Else
                XmlDoc = New System.Xml.XmlDocument
                XmlDoc.LoadXml(e.Result("ResponseXML"))

                XmlNode = XmlDoc.SelectSingleNode("/Error/Message")

                ResponseMessage = XmlNode.InnerText
            End If

            MessageBox.Show(ResponseMessage, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

        End If

    End Sub


    Private Sub DeleteItemBackgroundWorker_DoWork(ByVal sender As System.Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles DeleteItemBackgroundWorker.DoWork
        e.Result = MyREST.MakeRequest(e.Argument("RequestURL"), e.Argument("RequestMethod"), e.Argument("ExtraRequestHeaders"), "")
    End Sub


    Private Sub DeleteItemBackgroundWorker_RunWorkerCompleted(ByVal sender As Object, ByVal e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles DeleteItemBackgroundWorker.RunWorkerCompleted

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        If e.Result = True Then

            'remove the last item from the arraylist as it was just deleted
            DeleteQueueArrayList.RemoveAt(DeleteQueueArrayList.Count - 1)

            If DeleteQueueKeepGoing = False Then
                ToolStripStatusLabelAction.Text = ""
                ListViewAmazon.Enabled = True
                ToolStripButtonGoUp.Enabled = True
                ToolStripButtonRefresh.Enabled = True
                ToolStripButtonDelete.Enabled = True
                ToolStripButtonNewFolder.Enabled = True
                ToolStripButtonAbort.Visible = False

                MessageBox.Show("The operation was aborted.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

                ListPath()

            ElseIf DeleteQueueArrayList.Count > 0 Then

                ToolStripStatusLabelAction.Text = "Deleting " & DeleteQueueArrayList(DeleteQueueArrayList.Count - 1).KeyName & ", " & FormatNumber(DeleteQueueArrayList.Count, 0) & " items remaining...."

                Dim RequestURL As String
                RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", DeleteQueueArrayList(DeleteQueueArrayList.Count - 1).BucketName, DeleteQueueArrayList(DeleteQueueArrayList.Count - 1).KeyName, "")

                Dim RequestMethod As String = "DELETE"

                Dim ExtraRequestHeaders As New Dictionary(Of String, String)
                ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

                Dim AuthorizationValue As String
                AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, FormMain.TextBoxAWSAccessKeyId.Text, FormMain.TextBoxAWSSecretAccessKey.Text)
                ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

                'delete the next item
                Dim MyHashTable As New Hashtable
                MyHashTable.Add("RequestURL", RequestURL)
                MyHashTable.Add("RequestMethod", RequestMethod)
                MyHashTable.Add("ExtraRequestHeaders", ExtraRequestHeaders)

                DeleteItemBackgroundWorker.RunWorkerAsync(MyHashTable)
            Else
                ToolStripStatusLabelAction.Text = ""
                ListViewAmazon.Enabled = True
                ToolStripButtonGoUp.Enabled = True
                ToolStripButtonRefresh.Enabled = True
                ToolStripButtonDelete.Enabled = True
                ToolStripButtonNewFolder.Enabled = True
                ToolStripButtonAbort.Visible = False

                ListPath()
            End If

        Else

            ToolStripStatusLabelAction.Text = ""
            ListViewAmazon.Enabled = True
            ToolStripButtonGoUp.Enabled = True
            ToolStripButtonRefresh.Enabled = True
            ToolStripButtonDelete.Enabled = True
            ToolStripButtonNewFolder.Enabled = True
            ToolStripButtonAbort.Visible = False


            Dim ResponseMessage As String
            Dim XmlDoc As System.Xml.XmlDocument
            Dim XmlNode As System.Xml.XmlNode

            If MyREST.ResponseString = "" Then
                ResponseMessage = MyREST.ErrorDescription
            Else
                XmlDoc = New System.Xml.XmlDocument
                XmlDoc.LoadXml(MyREST.ResponseString)

                XmlNode = XmlDoc.SelectSingleNode("/Error/Message")

                ResponseMessage = XmlNode.InnerText
            End If

            MessageBox.Show(ResponseMessage, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

            ListPath()

        End If

    End Sub


    Private Sub ToolStripButtonAbort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonAbort.Click
        'abort any operations that are in progress and set a global variable to indicate that deletion should not continue
        If PopulateDeleteQueueListBucket.State = 1 Then
            PopulateDeleteQueueListBucket.Abort()
        ElseIf MyREST.State = 1 Then
            MyREST.Abort()
        End If
        DeleteQueueKeepGoing = False
    End Sub

End Class
